<!-- manual page source format generated by PolyglotMan v3.0.7, -->
<!-- available via anonymous ftp from ftp.cs.berkeley.edu:/ucb/people/phelps/tcltk/rman.tar.Z -->

<HTML>
<HEAD>
<TITLE>Man page for ip1arraysizes.1</TITLE>
</HEAD>
<BODY bgcolor=white>
<A HREF="#toc">Table of Contents</A><P>

<H2><A NAME="sect0" HREF="#toc0">Name</A></H2>

<P>
ip1arraysizes - do one level interprocedural propagation
of array sizes

<H2><A NAME="sect1" HREF="#toc1"><B>Synopsis</B></A></H2>

<P>
<B>ip1arraysizes</B> [ <I>options</I> ] <I>infile</I> <I>outfile</I> { <I>infile</I> <I>outfile</I>
}*

<H2><A NAME="sect2" HREF="#toc2"><B>Description</B></A></H2>

<P>
The <I>ip1arraysizes</I> program does very simple interprocedural
propagation of the sizes of arrays pointed to by pointer
parameters. It does this propagation through a single
level of procedure calls. If the sizes of the arrays are
available at all callsites and agree for a given parameter
for a given procedure, and the type of the parameter in
the procedure body is an array with unknown outer dimension,
the unknown outer dimension is replaced with the
constant calculated from the size of the array passed in.
Because only one level of procedure calls is handled, a
very efficient algorithm is used even though it's interprocedural.
Even the limited power of staying with a single
level of procedure call is still enough to help in
practice. The algorithm uses only one procedure in memory
at any given time. It makes two passes; each procedure is
read twice and written once, so it should take less time
than any two ordinary intraprocedural passes.

<H2><A NAME="sect3" HREF="#toc3"><B>Options</B></A></H2>

<P>
There are currently no command-line options.

<H2><A NAME="sect4" HREF="#toc4"><B>History</B></A></H2>

<P>
This program was written by Chris Wilson.
<P>

<HR><P>
<A NAME="toc"><B>Table of Contents</B></A><P>
<UL>
<LI><A NAME="toc0" HREF="#sect0">Name</A></LI>
<LI><A NAME="toc1" HREF="#sect1">Synopsis</A></LI>
<LI><A NAME="toc2" HREF="#sect2">Description</A></LI>
<LI><A NAME="toc3" HREF="#sect3">Options</A></LI>
<LI><A NAME="toc4" HREF="#sect4">History</A></LI>
</UL>
</BODY></HTML>
